Index: drivers/filesystems/btrfs/read.c
===================================================================
--- drivers/filesystems/btrfs/read.c	(révision 75772)
+++ drivers/filesystems/btrfs/read.c	(copie de travail)
@@ -3023,86 +2741,147 @@
         UINT64 len;
         extent* ext = CONTAINING_RECORD(le, extent, list_entry);
         EXTENT_DATA2* ed2;
-        
+
         if (!ext->ignore) {
-            ed = ext->data;
-            
+            ed = &ext->extent_data;
+
             ed2 = (ed->type == EXTENT_TYPE_REGULAR || ed->type == EXTENT_TYPE_PREALLOC) ? (EXTENT_DATA2*)ed->data : NULL;
-            
+
             len = ed2 ? ed2->num_bytes : ed->decoded_size;
-            
+
             if (ext->offset + len <= start) {
                 last_end = ext->offset + len;
                 goto nextitem;
             }
-            
+
             if (ext->offset > last_end && ext->offset > start + bytes_read) {
-                UINT32 read = min(length, ext->offset - max(start, last_end));
-                
+                UINT32 read = (UINT32)min(length, ext->offset - max(start, last_end));
+
                 RtlZeroMemory(data + bytes_read, read);
                 bytes_read += read;
                 length -= read;
             }
-            
+
             if (length == 0 || ext->offset > start + bytes_read + length)
                 break;
-            
+
             if (ed->encryption != BTRFS_ENCRYPTION_NONE) {
                 WARN("Encryption not supported\n");
                 Status = STATUS_NOT_IMPLEMENTED;
                 goto exit;
             }
-            
+
             if (ed->encoding != BTRFS_ENCODING_NONE) {
                 WARN("Other encodings not supported\n");
                 Status = STATUS_NOT_IMPLEMENTED;
                 goto exit;
             }
-            
+
             switch (ed->type) {
                 case EXTENT_TYPE_INLINE:
                 {
                     UINT64 off = start + bytes_read - ext->offset;
-                    UINT64 read = len - off;
-                    
-                    if (read > length) read = length;
-                    
-                    RtlCopyMemory(data + bytes_read, &ed->data[off], read);
-                    
-                    // FIXME - can we have compressed inline extents?
-                    
+                    UINT32 read;
+
+                    if (ed->compression == BTRFS_COMPRESSION_NONE) {
+                        read = (UINT32)min(min(len, ext->datalen) - off, length);
+
+                        RtlCopyMemory(data + bytes_read, &ed->data[off], read);
+                    } else if (ed->compression == BTRFS_COMPRESSION_ZLIB || ed->compression == BTRFS_COMPRESSION_LZO) {
+                        UINT8* decomp;
+                        BOOL decomp_alloc;
+                        UINT16 inlen = ext->datalen - (UINT16)offsetof(EXTENT_DATA, data[0]);
+
+                        if (ed->decoded_size == 0 || ed->decoded_size > 0xffffffff) {
+                            ERR("ed->decoded_size was invalid (%llx)\n", ed->decoded_size);
+                            Status = STATUS_INTERNAL_ERROR;
+                            goto exit;
+                        }
+
+                        read = (UINT32)min(ed->decoded_size - off, length);
+
+                        if (off > 0) {
+                            decomp = ExAllocatePoolWithTag(NonPagedPool, (UINT32)ed->decoded_size, ALLOC_TAG);
+                            if (!decomp) {
+                                ERR("out of memory\n");
+                                Status = STATUS_INSUFFICIENT_RESOURCES;
+                                goto exit;
+                            }
+
+                            decomp_alloc = TRUE;
+                        } else {
+                            decomp = data + bytes_read;
+                            decomp_alloc = FALSE;
+                        }
+
+                        if (ed->compression == BTRFS_COMPRESSION_ZLIB) {
+                            Status = zlib_decompress(ed->data, inlen, decomp, (UINT32)(read + off));
+                            if (!NT_SUCCESS(Status)) {
+                                ERR("zlib_decompress returned %08x\n", Status);
+                                if (decomp_alloc) ExFreePool(decomp);
+                                goto exit;
+                            }
+                        } else if (ed->compression == BTRFS_COMPRESSION_LZO) {
+                            if (inlen < sizeof(UINT32)) {
+                                ERR("extent data was truncated\n");
+                                Status = STATUS_INTERNAL_ERROR;
+                                if (decomp_alloc) ExFreePool(decomp);
+                                goto exit;
+                            } else
+                                inlen -= sizeof(UINT32);
+
+                            Status = lzo_decompress(ed->data + sizeof(UINT32), inlen, decomp, (UINT32)(read + off), sizeof(UINT32));
+                            if (!NT_SUCCESS(Status)) {
+                                ERR("lzo_decompress returned %08x\n", Status);
+                                if (decomp_alloc) ExFreePool(decomp);
+                                goto exit;
+                            }
+                        }
+
+                        if (decomp_alloc) {
+                            RtlCopyMemory(data + bytes_read, decomp + off, read);
+                            ExFreePool(decomp);
+                        }
+                    } else {
+                        ERR("unhandled compression type %x\n", ed->compression);
+                        Status = STATUS_NOT_IMPLEMENTED;
+                        goto exit;
+                    }
+
                     bytes_read += read;
                     length -= read;
+
                     break;
                 }
-                
+
                 case EXTENT_TYPE_REGULAR:
                 {
                     UINT64 off = start + bytes_read - ext->offset;
                     UINT32 to_read, read;
                     UINT8* buf;
+                    BOOL mdl = (Irp && Irp->MdlAddress) ? TRUE : FALSE;
                     BOOL buf_free;
-                    UINT32 bumpoff = 0;
-                    UINT64 addr, lockaddr, locklen;
+                    UINT32 bumpoff = 0, *csum;
+                    UINT64 addr;
                     chunk* c;
-                    
-                    read = len - off;
-                    if (read > length) read = length;
-                    
+
+                    read = (UINT32)(len - off);
+                    if (read > length) read = (UINT32)length;
+
                     if (ed->compression == BTRFS_COMPRESSION_NONE) {
                         addr = ed2->address + ed2->offset + off;
-                        to_read = sector_align(read, fcb->Vcb->superblock.sector_size);
-                        
+                        to_read = (UINT32)sector_align(read, fcb->Vcb->superblock.sector_size);
+
                         if (addr % fcb->Vcb->superblock.sector_size > 0) {
                             bumpoff = addr % fcb->Vcb->superblock.sector_size;
                             addr -= bumpoff;
-                            to_read = sector_align(read + bumpoff, fcb->Vcb->superblock.sector_size);
+                            to_read = (UINT32)sector_align(read + bumpoff, fcb->Vcb->superblock.sector_size);
                         }
                     } else {
                         addr = ed2->address;
-                        to_read = sector_align(ed2->size, fcb->Vcb->superblock.sector_size);
+                        to_read = (UINT32)sector_align(ed2->size, fcb->Vcb->superblock.sector_size);
                     }
-                    
+
                     if (ed->compression == BTRFS_COMPRESSION_NONE && start % fcb->Vcb->superblock.sector_size == 0 &&
                         length % fcb->Vcb->superblock.sector_size == 0) {
                         buf = data + bytes_read;
@@ -3110,101 +2889,166 @@
                     } else {
                         buf = ExAllocatePoolWithTag(PagedPool, to_read, ALLOC_TAG);
                         buf_free = TRUE;
-                        
+
                         if (!buf) {
                             ERR("out of memory\n");
                             Status = STATUS_INSUFFICIENT_RESOURCES;
                             goto exit;
                         }
+
+                        mdl = FALSE;
                     }
-                    
+
                     c = get_chunk_from_address(fcb->Vcb, addr);
-                    
+
                     if (!c) {
                         ERR("get_chunk_from_address(%llx) failed\n", addr);
-                        
+
                         if (buf_free)
                             ExFreePool(buf);
-                        
+
                         goto exit;
                     }
-                    
-                    if (c->chunk_item->type & BLOCK_FLAG_RAID5 || c->chunk_item->type & BLOCK_FLAG_RAID6) {
-                        get_raid56_lock_range(c, addr, to_read, &lockaddr, &locklen);
-                        chunk_lock_range(fcb->Vcb, c, lockaddr, locklen);
-                    }
-                    
-                    Status = read_data(fcb->Vcb, addr, to_read, ext->csum ? &ext->csum[off / fcb->Vcb->superblock.sector_size] : NULL, FALSE,
-                                       buf, c, NULL, Irp, check_nocsum_parity);
+
+                    if (ext->csum) {
+                        if (ed->compression == BTRFS_COMPRESSION_NONE)
+                            csum = &ext->csum[off / fcb->Vcb->superblock.sector_size];
+                        else
+                            csum = ext->csum;
+                    } else
+                        csum = NULL;
+
+                    Status = read_data(fcb->Vcb, addr, to_read, csum, FALSE, buf, c, NULL, Irp, 0, mdl,
+                                       fcb && fcb->Header.Flags2 & FSRTL_FLAG2_IS_PAGING_FILE ? HighPagePriority : NormalPagePriority);
                     if (!NT_SUCCESS(Status)) {
                         ERR("read_data returned %08x\n", Status);
-                        
-                        if (c->chunk_item->type & BLOCK_FLAG_RAID5 || c->chunk_item->type & BLOCK_FLAG_RAID6)
-                            chunk_unlock_range(fcb->Vcb, c, lockaddr, locklen);
-                        
+
                         if (buf_free)
                             ExFreePool(buf);
-                        
+
                         goto exit;
                     }
-                    
-                    if (c->chunk_item->type & BLOCK_FLAG_RAID5 || c->chunk_item->type & BLOCK_FLAG_RAID6)
-                        chunk_unlock_range(fcb->Vcb, c, lockaddr, locklen);
-                    
+
                     if (ed->compression == BTRFS_COMPRESSION_NONE) {
                         if (buf_free)
                             RtlCopyMemory(data + bytes_read, buf + bumpoff, read);
                     } else {
-                        UINT8* decomp = NULL;
-                        
-                        // FIXME - don't mess around with decomp if we're reading the whole extent
-                        
-                        decomp = ExAllocatePoolWithTag(PagedPool, ed->decoded_size, ALLOC_TAG);
-                        if (!decomp) {
-                            ERR("out of memory\n");
+                        UINT8 *decomp = NULL, *buf2;
+                        ULONG outlen, inlen, off2;
+                        UINT32 inpageoff = 0;
+
+                        off2 = (ULONG)(ed2->offset + off);
+                        buf2 = buf;
+                        inlen = (ULONG)ed2->size;
+
+                        if (ed->compression == BTRFS_COMPRESSION_LZO) {
+                            ULONG inoff = sizeof(UINT32);
+
+                            inlen -= sizeof(UINT32);
+
+                            // If reading a few sectors in, skip to the interesting bit
+                            while (off2 > LINUX_PAGE_SIZE) {
+                                UINT32 partlen;
+
+                                if (inlen < sizeof(UINT32))
+                                    break;
+
+                                partlen = *(UINT32*)(buf2 + inoff);
+
+                                if (partlen < inlen) {
+                                    off2 -= LINUX_PAGE_SIZE;
+                                    inoff += partlen + sizeof(UINT32);
+                                    inlen -= partlen + sizeof(UINT32);
+
+                                    if (LINUX_PAGE_SIZE - (inoff % LINUX_PAGE_SIZE) < sizeof(UINT32))
+                                        inoff = ((inoff / LINUX_PAGE_SIZE) + 1) * LINUX_PAGE_SIZE;
+                                } else
+                                    break;
+                            }
+
+                            buf2 = &buf2[inoff];
+                            inpageoff = inoff % LINUX_PAGE_SIZE;
+                        }
+
+                        if (off2 != 0) {
+                            outlen = off2 + min(read, (UINT32)(ed2->num_bytes - off));
+
+                            decomp = ExAllocatePoolWithTag(PagedPool, outlen, ALLOC_TAG);
+                            if (!decomp) {
+                                ERR("out of memory\n");
+                                ExFreePool(buf);
+                                Status = STATUS_INSUFFICIENT_RESOURCES;
+                                goto exit;
+                            }
+                        } else
+                            outlen = min(read, (UINT32)(ed2->num_bytes - off));
+
+                        if (ed->compression == BTRFS_COMPRESSION_ZLIB) {
+                            Status = zlib_decompress(buf2, inlen, decomp ? decomp : (data + bytes_read), outlen);
+
+                            if (!NT_SUCCESS(Status)) {
+                                ERR("zlib_decompress returned %08x\n", Status);
+                                ExFreePool(buf);
+
+                                if (decomp)
+                                    ExFreePool(decomp);
+
+                                goto exit;
+                            }
+                        } else if (ed->compression == BTRFS_COMPRESSION_LZO) {
+                            Status = lzo_decompress(buf2, inlen, decomp ? decomp : (data + bytes_read), outlen, inpageoff);
+
+                            if (!NT_SUCCESS(Status)) {
+                                ERR("lzo_decompress returned %08x\n", Status);
+                                ExFreePool(buf);
+
+                                if (decomp)
+                                    ExFreePool(decomp);
+
+                                goto exit;
+                            }
+                        } else {
+                            ERR("unsupported compression type %x\n", ed->compression);
+                            Status = STATUS_NOT_SUPPORTED;
+
                             ExFreePool(buf);
-                            Status = STATUS_INSUFFICIENT_RESOURCES;
+
+                            if (decomp)
+                                ExFreePool(decomp);
+
                             goto exit;
                         }
-                        
-                        Status = decompress(ed->compression, buf, ed2->size, decomp, ed->decoded_size);
-                        
-                        if (!NT_SUCCESS(Status)) {
-                            ERR("decompress returned %08x\n", Status);
-                            ExFreePool(buf);
+
+                        if (decomp) {
+                            RtlCopyMemory(data + bytes_read, decomp + off2, (size_t)min(read, ed2->num_bytes - off));
                             ExFreePool(decomp);
-                            goto exit;
                         }
-                        
-                        RtlCopyMemory(data + bytes_read, decomp + ed2->offset + off, min(read, ed2->num_bytes - off));
-                        
-                        ExFreePool(decomp);
                     }
-                    
+
                     if (buf_free)
                         ExFreePool(buf);
-                    
+
                     bytes_read += read;
                     length -= read;
-                    
+
                     break;
                 }
-            
+
                 case EXTENT_TYPE_PREALLOC:
                 {
                     UINT64 off = start + bytes_read - ext->offset;
-                    UINT32 read = len - off;
-                    
-                    if (read > length) read = length;
+                    UINT32 read = (UINT32)(len - off);
 
+                    if (read > length) read = (UINT32)length;
+
                     RtlZeroMemory(data + bytes_read, read);
 
                     bytes_read += read;
                     length -= read;
-                    
+
                     break;
                 }
-                    
+
                 default:
                     WARN("Unsupported extent data type %u\n", ed->type);
                     Status = STATUS_NOT_IMPLEMENTED;
@@ -3212,7 +3056,7 @@
             }
 
             last_end = ext->offset + len;
-            
+
             if (length == 0)
                 break;
         }
@@ -3220,45 +3064,45 @@
 nextitem:
         le = le->Flink;
     }
-    
+
     if (length > 0 && start + bytes_read < fcb->inode_item.st_size) {
-        UINT32 read = min(fcb->inode_item.st_size - start - bytes_read, length);
-        
+        UINT32 read = (UINT32)min(fcb->inode_item.st_size - start - bytes_read, length);
+
         RtlZeroMemory(data + bytes_read, read);
-        
+
         bytes_read += read;
         length -= read;
     }
-    
+
     Status = STATUS_SUCCESS;
     if (pbr)
         *pbr = bytes_read;
-    
+
 #ifdef DEBUG_STATS
     time2 = KeQueryPerformanceCounter(NULL);
-    
+
     fcb->Vcb->stats.num_reads++;
     fcb->Vcb->stats.data_read += bytes_read;
     fcb->Vcb->stats.read_total_time += time2.QuadPart - time1.QuadPart;
 #endif
-    
+
 exit:
     return Status;
 }
 
-NTSTATUS do_read(PIRP Irp, BOOL wait, ULONG* bytes_read) {
+NTSTATUS do_read(PIRP Irp, BOOLEAN wait, ULONG* bytes_read) {
     PIO_STACK_LOCATION IrpSp = IoGetCurrentIrpStackLocation(Irp);
     PFILE_OBJECT FileObject = IrpSp->FileObject;
     fcb* fcb = FileObject->FsContext;
-    UINT8* data;
-    ULONG length, addon = 0;
+    UINT8* data = NULL;
+    ULONG length = IrpSp->Parameters.Read.Length, addon = 0;
     UINT64 start = IrpSp->Parameters.Read.ByteOffset.QuadPart;
-    length = IrpSp->Parameters.Read.Length;
+
     *bytes_read = 0;
-    
+
     if (!fcb || !fcb->Vcb || !fcb->subvol)
         return STATUS_INTERNAL_ERROR;
-    
+
     TRACE("file = %S (fcb = %p)\n", file_desc(FileObject), fcb);
     TRACE("offset = %llx, length = %x\n", start, length);
     TRACE("paging_io = %s, no cache = %s\n", Irp->Flags & IRP_PAGING_IO ? "TRUE" : "FALSE", Irp->Flags & IRP_NOCACHE ? "TRUE" : "FALSE");
@@ -3265,71 +3109,70 @@
 
     if (!fcb->ads && fcb->type == BTRFS_TYPE_DIRECTORY)
         return STATUS_INVALID_DEVICE_REQUEST;
-    
+
     if (!(Irp->Flags & IRP_PAGING_IO) && !FsRtlCheckLockForReadAccess(&fcb->lock, Irp)) {
         WARN("tried to read locked region\n");
         return STATUS_FILE_LOCK_CONFLICT;
     }
-    
+
     if (length == 0) {
         TRACE("tried to read zero bytes\n");
         return STATUS_SUCCESS;
     }
-    
-    if (start >= fcb->Header.FileSize.QuadPart) {
+
+    if (start >= (UINT64)fcb->Header.FileSize.QuadPart) {
         TRACE("tried to read with offset after file end (%llx >= %llx)\n", start, fcb->Header.FileSize.QuadPart);
         return STATUS_END_OF_FILE;
     }
-    
+
     TRACE("FileObject %p fcb %p FileSize = %llx st_size = %llx (%p)\n", FileObject, fcb, fcb->Header.FileSize.QuadPart, fcb->inode_item.st_size, &fcb->inode_item.st_size);
-//     int3;
-    
+
     if (Irp->Flags & IRP_NOCACHE || !(IrpSp->MinorFunction & IRP_MN_MDL)) {
-        data = map_user_buffer(Irp);
-        
+        data = map_user_buffer(Irp, fcb->Header.Flags2 & FSRTL_FLAG2_IS_PAGING_FILE ? HighPagePriority : NormalPagePriority);
+
         if (Irp->MdlAddress && !data) {
             ERR("MmGetSystemAddressForMdlSafe returned NULL\n");
             return STATUS_INSUFFICIENT_RESOURCES;
         }
-        
-        if (start >= fcb->Header.ValidDataLength.QuadPart) {
-            length = min(length, min(start + length, fcb->Header.FileSize.QuadPart) - fcb->Header.ValidDataLength.QuadPart);
+
+        if (start >= (UINT64)fcb->Header.ValidDataLength.QuadPart) {
+            length = (ULONG)min(length, min(start + length, (UINT64)fcb->Header.FileSize.QuadPart) - fcb->Header.ValidDataLength.QuadPart);
             RtlZeroMemory(data, length);
             Irp->IoStatus.Information = *bytes_read = length;
             return STATUS_SUCCESS;
         }
-        
-        if (length + start > fcb->Header.ValidDataLength.QuadPart) {
-            addon = min(start + length, fcb->Header.FileSize.QuadPart) - fcb->Header.ValidDataLength.QuadPart;
+
+        if (length + start > (UINT64)fcb->Header.ValidDataLength.QuadPart) {
+            addon = (ULONG)(min(start + length, (UINT64)fcb->Header.FileSize.QuadPart) - fcb->Header.ValidDataLength.QuadPart);
             RtlZeroMemory(data + (fcb->Header.ValidDataLength.QuadPart - start), addon);
-            length = fcb->Header.ValidDataLength.QuadPart - start;
+            length = (ULONG)(fcb->Header.ValidDataLength.QuadPart - start);
         }
     }
-        
+
     if (!(Irp->Flags & IRP_NOCACHE)) {
         NTSTATUS Status = STATUS_SUCCESS;
-        
+
         _SEH2_TRY {
             if (!FileObject->PrivateCacheMap) {
                 CC_FILE_SIZES ccfs;
-                
+
                 ccfs.AllocationSize = fcb->Header.AllocationSize;
                 ccfs.FileSize = fcb->Header.FileSize;
                 ccfs.ValidDataLength = fcb->Header.ValidDataLength;
-                
+
                 init_file_cache(FileObject, &ccfs);
             }
-            
+
             if (IrpSp->MinorFunction & IRP_MN_MDL) {
                 CcMdlRead(FileObject,&IrpSp->Parameters.Read.ByteOffset, length, &Irp->MdlAddress, &Irp->IoStatus);
             } else {
-                if (CcCopyReadEx) {
+                if (fCcCopyReadEx) {
                     TRACE("CcCopyReadEx(%p, %llx, %x, %u, %p, %p, %p, %p)\n", FileObject, IrpSp->Parameters.Read.ByteOffset.QuadPart,
                           length, wait, data, &Irp->IoStatus, Irp->Tail.Overlay.Thread);
                     TRACE("sizes = %llx, %llx, %llx\n", fcb->Header.AllocationSize, fcb->Header.FileSize, fcb->Header.ValidDataLength);
-                    if (!CcCopyReadEx(FileObject, &IrpSp->Parameters.Read.ByteOffset, length, wait, data, &Irp->IoStatus, Irp->Tail.Overlay.Thread)) {
+                    if (!fCcCopyReadEx(FileObject, &IrpSp->Parameters.Read.ByteOffset, length, wait, data, &Irp->IoStatus, Irp->Tail.Overlay.Thread)) {
                         TRACE("CcCopyReadEx could not wait\n");
-                        
+
                         IoMarkIrpPending(Irp);
                         return STATUS_PENDING;
                     }
@@ -3339,7 +3182,7 @@
                     TRACE("sizes = %llx, %llx, %llx\n", fcb->Header.AllocationSize, fcb->Header.FileSize, fcb->Header.ValidDataLength);
                     if (!CcCopyRead(FileObject, &IrpSp->Parameters.Read.ByteOffset, length, wait, data, &Irp->IoStatus)) {
                         TRACE("CcCopyRead could not wait\n");
-                        
+
                         IoMarkIrpPending(Irp);
                         return STATUS_PENDING;
                     }
@@ -3349,47 +3192,47 @@
         } _SEH2_EXCEPT (EXCEPTION_EXECUTE_HANDLER) {
             Status = _SEH2_GetExceptionCode();
         } _SEH2_END;
-        
+
         if (NT_SUCCESS(Status)) {
             Status = Irp->IoStatus.Status;
             Irp->IoStatus.Information += addon;
-            *bytes_read = Irp->IoStatus.Information;
+            *bytes_read = (ULONG)Irp->IoStatus.Information;
         } else
             ERR("EXCEPTION - %08x\n", Status);
-        
+
         return Status;
     } else {
         NTSTATUS Status;
-        
+
         if (!wait) {
             IoMarkIrpPending(Irp);
             return STATUS_PENDING;
         }
-        
+
         if (!(Irp->Flags & IRP_PAGING_IO) && FileObject->SectionObjectPointer->DataSectionObject) {
             IO_STATUS_BLOCK iosb;
-            
+
             CcFlushCache(FileObject->SectionObjectPointer, &IrpSp->Parameters.Read.ByteOffset, length, &iosb);
-            
+
             if (!NT_SUCCESS(iosb.Status)) {
                 ERR("CcFlushCache returned %08x\n", iosb.Status);
                 return iosb.Status;
             }
         }
-        
+
         if (fcb->ads)
             Status = read_stream(fcb, data, start, length, bytes_read);
         else
-            Status = read_file(fcb, data, start, length, bytes_read, Irp, TRUE);
-        
+            Status = read_file(fcb, data, start, length, bytes_read, Irp);
+
         *bytes_read += addon;
         TRACE("read %u bytes\n", *bytes_read);
-        
+
         Irp->IoStatus.Information = *bytes_read;
-        
+
         if (diskacc && Status != STATUS_PENDING) {
             PETHREAD thread = NULL;
-            
+
             if (Irp->Tail.Overlay.Thread && !IoIsSystemThread(Irp->Tail.Overlay.Thread))
                 thread = Irp->Tail.Overlay.Thread;
             else if (!IoIsSystemThread(PsGetCurrentThread()))
@@ -3396,88 +3239,92 @@
                 thread = PsGetCurrentThread();
             else if (IoIsSystemThread(PsGetCurrentThread()) && IoGetTopLevelIrp() == Irp)
                 thread = PsGetCurrentThread();
-            
+
             if (thread)
-                PsUpdateDiskCounters(PsGetThreadProcess(thread), *bytes_read, 0, 1, 0, 0);
+                fPsUpdateDiskCounters(PsGetThreadProcess(thread), *bytes_read, 0, 1, 0, 0);
         }
-        
+
         return Status;
     }
 }
 
-NTSTATUS STDCALL drv_read(PDEVICE_OBJECT DeviceObject, PIRP Irp) {
+_Dispatch_type_(IRP_MJ_READ)
+_Function_class_(DRIVER_DISPATCH)
+NTSTATUS drv_read(PDEVICE_OBJECT DeviceObject, PIRP Irp) {
     device_extension* Vcb = DeviceObject->DeviceExtension;
     PIO_STACK_LOCATION IrpSp = IoGetCurrentIrpStackLocation(Irp);
     PFILE_OBJECT FileObject = IrpSp->FileObject;
-    ULONG bytes_read;
+    ULONG bytes_read = 0;
     NTSTATUS Status;
     BOOL top_level;
     fcb* fcb;
     ccb* ccb;
-    BOOL fcb_lock = FALSE, wait;
-    
+    BOOLEAN fcb_lock = FALSE, wait;
+
     FsRtlEnterFileSystem();
-    
+
     top_level = is_top_level(Irp);
-    
+
     TRACE("read\n");
-    
-    if (Vcb && Vcb->type == VCB_TYPE_PARTITION0) {
-        Status = part0_passthrough(DeviceObject, Irp);
+
+    if (Vcb && Vcb->type == VCB_TYPE_VOLUME) {
+        Status = vol_read(DeviceObject, Irp);
         goto exit2;
+    } else if (!Vcb || Vcb->type != VCB_TYPE_FS) {
+        Status = STATUS_INVALID_PARAMETER;
+        goto end;
     }
-    
+
     Irp->IoStatus.Information = 0;
-    
+
     if (IrpSp->MinorFunction & IRP_MN_COMPLETE) {
         CcMdlReadComplete(IrpSp->FileObject, Irp->MdlAddress);
-        
+
         Irp->MdlAddress = NULL;
         Status = STATUS_SUCCESS;
-        bytes_read = 0;
-        
+
         goto exit;
     }
-    
+
     fcb = FileObject->FsContext;
-    
+
     if (!fcb) {
         ERR("fcb was NULL\n");
         Status = STATUS_INVALID_PARAMETER;
         goto exit;
     }
-    
+
     ccb = FileObject->FsContext2;
-    
+
     if (!ccb) {
         ERR("ccb was NULL\n");
         Status = STATUS_INVALID_PARAMETER;
         goto exit;
     }
-    
+
     if (Irp->RequestorMode == UserMode && !(ccb->access & FILE_READ_DATA)) {
         WARN("insufficient privileges\n");
         Status = STATUS_ACCESS_DENIED;
         goto exit;
     }
-    
+
     if (fcb == Vcb->volume_fcb) {
         TRACE("reading volume FCB\n");
-        
+
         IoSkipCurrentIrpStackLocation(Irp);
-    
+
         Status = IoCallDriver(Vcb->Vpb->RealDevice, Irp);
-        
+
         goto exit2;
     }
-    
+
     wait = IoIsOperationSynchronous(Irp);
-    
+
     // Don't offload jobs when doing paging IO - otherwise this can lead to
     // deadlocks in CcCopyRead.
     if (Irp->Flags & IRP_PAGING_IO)
         wait = TRUE;
-    
+
     if (!ExIsResourceAcquiredSharedLite(fcb->Header.Resource)) {
         if (!ExAcquireResourceSharedLite(fcb->Header.Resource, wait)) {
             Status = STATUS_PENDING;
@@ -3484,29 +3331,26 @@
             IoMarkIrpPending(Irp);
             goto exit;
         }
-        
+
         fcb_lock = TRUE;
     }
-    
+
     Status = do_read(Irp, wait, &bytes_read);
-    
-exit:
+
     if (fcb_lock)
         ExReleaseResourceLite(fcb->Header.Resource);
 
-    Irp->IoStatus.Status = Status;
-    
+exit:
     if (FileObject->Flags & FO_SYNCHRONOUS_IO && !(Irp->Flags & IRP_PAGING_IO))
         FileObject->CurrentByteOffset.QuadPart = IrpSp->Parameters.Read.ByteOffset.QuadPart + (NT_SUCCESS(Status) ? bytes_read : 0);
-    
-    // fastfat doesn't do this, but the Wine ntdll file test seems to think we ought to
-    if (Irp->UserIosb)
-        *Irp->UserIosb = Irp->IoStatus;
-    
+
+end:
+    Irp->IoStatus.Status = Status;
+
     TRACE("Irp->IoStatus.Status = %08x\n", Irp->IoStatus.Status);
     TRACE("Irp->IoStatus.Information = %lu\n", Irp->IoStatus.Information);
     TRACE("returning %08x\n", Status);
-    
+
     if (Status != STATUS_PENDING)
         IoCompleteRequest(Irp, IO_NO_INCREMENT);
     else {
@@ -3513,12 +3357,12 @@
         if (!add_thread_job(Vcb, Irp))
             do_read_job(Irp);
     }
-    
+
 exit2:
-    if (top_level) 
+    if (top_level)
         IoSetTopLevelIrp(NULL);
-    
+
     FsRtlExitFileSystem();
-    
+
     return Status;
 }
